unit disk;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils,dos,crt,wind,comms,scrn,globals;
procedure directory;
procedure direct;
procedure load;
procedure save;
function getname(s:shortstring):shortstring;

implementation
type
    glob   = file of config_data;
    rxdat  = file of reciever_data;


var
   globfile: glob;
   rxio : rxdat;
   filename: string[12];

{***************************************************************************}
function getname(s:shortstring):shortstring;


var
   curpos,beg,j:byte;
   i,iprev:char;

begin
i:=#01;
for j:=length(s)+1 to 255 do s[j]:=' ';
curpos:=1;
cursoron;

repeat
begin
     if curpos>15 then
        begin
        beg:=curpos-14;
        gotoxy(2,3);
        for j:= beg to curpos do write (s[j]);
        end
     else
        begin
        beg:=1;
        gotoxy(2,3);
        for j:= 1 to 15 do write (s[j]);
        end;
     gotoxy(curpos-beg+2,3);
     iprev:=i;
     i:=readkey;

     if ((i in['0'..'9','a'..'z','A'..'Z','.','\',':','@','_',' ']) and(curpos<>25) and (iprev<>#0)) then
        begin
        s:=copy(s,1,curpos-1)+i;
        inc(curpos);
        end;

     if (((i=#83)and (iprev=#0)) or (i=#8)) and (curpos<>1) then
        begin
        dec(curpos);
        s:=copy(s,1,curpos-1);
        end;
     if i<>#13 then  for j:=curpos to 255 do s[j]:=' ';
     getname:=s;
     if i=#27 then
              begin
              getname:='';  {pressed escape key}
              i:=#13;
              end;
end;
until i=chr(13);
gotoxy(1,4);
write('                   ');
cursoroff;
end;


{****************************************************************************}
procedure directory;
var
   info:searchrec;
   count,scroll:integer;
   i:char;

begin
window(10,7,70,15);
clrscr;
setwindow(10,7,60,10);
gotoxy(18,1);
write(' Directory ',name);
window(10,9,68,15);
gotoxy(1,1);
findfirst('*.gdt',archive,info);
count:=0;
scroll:=0;
while doserror=0 do
      begin
      write(info.name:17);
      inc(count);
      if count=3 then
         begin
         count:=0;
         writeln;
         inc(scroll);
         end;
      if scroll=6 then
         begin
         write('More, press any key...');
         i:=readkey;
         scroll:=0;
         writeln;
         end;
      findnext(info);
      end;
      writeln;
      write('No More Files');

end;




{**************************************************************************}
procedure direct;

var
   iocode,len:integer;
   olds:string;

begin
olds:=name;
txt[0]:='    Directory    ';
txt[1]:='';
txt[2]:='';
drawwindow(30,15,2);

repeat
begin
    name:=getname(name);
    if name<>'' then
         begin
         len:=length(name);
         if name[len]=':' then name:=copy(name,1,len)+'\';
                     {fudge to make chdir access disk}
                     {$I-}
         Chdir(name);
                     {$I+}
         iocode:=ioresult;
         if iocode<>0 then
            begin
            gotoxy(1,4);
            write('     ERROR  ');
            write(^g);
            end;
         end
    else
        begin
        iocode:=0;
        chdir(path);
        name:=olds;
        end;
end;
until iocode=0;
end;
{*************************************************************************}
procedure save;

var
   iocode,i:integer;

begin
directory;
txt[0]:='      Save          ';
txt[1]:='';
txt[2]:='';
window(1,1,80,25);
drawwindow(30,18,2);
repeat
      begin
      filename:=getname(filename);
      if filename<>'' then
         begin
         {parse name for . and length}
         i:=0;
         repeat
               inc(i)
         until (i=8) or (copy(filename,i,1)='.') or (i=length(filename));
         if copy(filename,i,1)<>'.' then inc(i);
         filename:=copy(filename,1,i-1);

       {$I-}
         assign(globfile,filename+'.gdt');
         rewrite(globfile);
       {$I+}
         iocode:=ioresult;
       {$I-}
         assign(rxio,filename+'.rxd');
         rewrite(rxio);
       {$I+}
         iocode:=iocode+ioresult;


         if iocode=0 then
            begin
            {$I-}
            write(globfile,globdat);
            close(globfile);
            {$I+}
            iocode:=ioresult;
            {$I-}
            {only receiver[0] used for MTL838}
            write(rxio,receiver[0]^);
            close(rxio);
            {$I+}
            iocode:=iocode+ioresult;
            end;
         end
      else
          iocode:=0;
      if iocode<>0 then
         begin
         write(^g);
         gotoxy(2,4);
         write('Disk Access Error');
         end;
      end;
 until iocode=0 ;
 end;

{*************************************************************************}
procedure load;

var
   iocode,i:integer;
   dload:byte;
begin
dload:=0;
directory;
txt[0]:='      Load        ';
txt[1]:='';
txt[2]:='';
window(1,1,80,25);
drawwindow(30,18,2);

repeat
      begin
      filename:=getname(filename);
      if filename<>'' then
         begin
         dload:=1;
         {parse name for . and length}
         i:=0;
         repeat
               inc(i)
         until (i=8) or (copy(filename,i,1)='.') or (i=length(filename));
         if copy(filename,i,1)<>'.' then inc(i);

         filename:=copy(filename,1,i-1);

         {$I-}
         assign(globfile,filename+'.gdt');
         reset(globfile);
         {$I+}
         iocode:=ioresult;
         {$I-}
         assign(rxio,filename+'.rxd');
         reset(rxio);
         {$I+}
         iocode:=iocode+ioresult;
         if iocode=0 then
            begin
            {$I-}
            read(globfile,globdat);
            close(globfile);
            {$I+}
            iocode:=ioresult;

            {$I-}
            {only receiver[0] used for MTL838}
            read(rxio,receiver[0]^);
            close(rxio);
            {$I+}
            iocode:=iocode+ioresult;
            end;
         end
      else
          iocode:=0;
      if iocode<>0 then
         begin
         dload:=0;
         write(^g);
         gotoxy(2,4);
         write('Invalid Filename');
         end;
      end;
 until iocode=0 ;
 txno:=1;
 chno:=1;

{ data LOADED from file will not be automatically downloaded to the receivers }
{ so if ONLINE then give user the option to perform this download }
if online and (dload=1)
then begin
    backgnd(0);
    fillscn(xcur,ycur);
    window(1,1,80,25);
    gotoxy(3,21);
    writeln('After Loading configuration is not');
    gotoxy(3,22);
    writeln('automatically updated.');
    txt[0]:='    Download ?    ';
    txt[1]:='       Yes        ';
    txt[2]:='       No         ';
    drawwindow(30,15,2);
    dload:=selection(2,2,2); { default/esc option is NO }
    if dload=1 then download;
    end;
end;
begin
filename:='                   ';
filename:='';
end.

