unit hardc;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils,crt,windows,messages,dos,comms,wind,scrn,misc,globals;

procedure hcopy;
procedure inithardcopy;
  function stg(x,i:byte):string;
implementation
var
   rx,tx,ch:byte;
   hcfile:string[12];



function stg(x,i:byte):string;
var
   y:string;

begin
     str(x:i,y);
     stg:=y

end;

{*************************************************************************}
procedure outpt(outfile:string);  {outfile:string}

var
   prt:text;
   t:string[15];
   trx,i:integer;
   d,m,y,w:word;
   a,b:boolean;

begin
getdate(y,m,d,w);
gotoxy(1,25);
textbackground(black);
textcolor(white);
write(message[53]);

{$I-}
assign(prt,outfile);

rewrite(prt);
writeln(prt);
{$I+}
if ioresult=0 then
begin

  with receiver[rx]^ do
     begin
     {$I-}
     writeln(prt,'               Configuration Report MTL 838 Modbus Multiplexer  ');
     writeln(prt,'            ====================================================');
     writeln(prt,'       Tag Name: ',tag_field,'                  Date: ',d,'/',m,'/',y);
     writeln(prt,'       Software Versions: HCA ',hcaver);
     writeln(prt,'                           IP ',ipver);
     case mod_baud of
	  1:i:=300;
	  2:i:=600;
	  3:i:=1200;
	  4:i:=2400;
	  5:i:=4800;
	  6:i:=9600;
          7:i:=19200;
	  else i:=0;
	  end; {case mod_baud}

           case data_format of
                0..1:t:=' '+dformatstg[data_format+1];
                4..14:t:=' '+dformatstg[data_format-1];
                16..18:t:=' '+dformatstg[data_format-2];
                else t:='   unknown   ';
             end; {case data_format}


     writeln(prt,'       Baudrate:    ',i:5,
              '                    Data Format:',t);
     case units of
          1:t:='  Centigrade';
          2:t:='  Fahrenheit';
          3:t:='  Kelvin    ';
          else t:='     ?    ';
          end;

     writeln(prt,'       Databits:      ',receiver[recno]^.mod_dbits:1,
              '                Temperature Units:',t);
     case mod_parity of
          0:t:='none';
          1:t:='odd';
          2:t:='even';
          end;
     writeln(prt,'         Parity:     ',t); {parity}
     writeln(prt,'       Stopbits:      ',receiver[recno]^.mod_stop:1);
     writeln(prt,' Line Rejection:    ',(line_rej*10)+50,'Hz');

  for trx:=1 to no_of_tx do
       with transmitter[trx] do
              begin
                 writeln(prt);
                 writeln(prt,'    Transmitter:   ',trx:1,' of ',no_of_tx,'     Type: MTL 83',txtype:1);
                 writeln(prt,'-----------------------------------------------------------------------------');
                 writeln(prt,' Ch No  Input Type          Alarms               Scaling Parameters');
                 writeln(prt,'-----------------------------------------------------------------------------');

                 if txtype=1 then rtd:=IsRtd(rx,trx)
                             else rtd:=false;
                 for ch:=1 to (3-txtype)*8 do
                     with channel[ch] do
			   begin
			   if not(rtd and (ch=16)) then
                            begin
                                  disp[2,1]:=iptypestring(txtype,input_type);
                            if (input_type<>15) or (txtype=2) then
                                 begin
                                 if not(rtd or (txtype=2)) then
                                     disp[2,2]:=message[thc_drive+27]
                                 else
                                     disp[2,2]:=message[95];
                                 disp[2,3]:=fstr(high_alarm,3)+'     ';
                                 disp[2,4]:=fstr(low_alarm,3)+'      ';
                                 end
                                else
                                  begin
                                  disp[2,3]:=message[95];
                                  disp[2,4]:=message[95];
                                  end; {if input_type..}
                              end
                           else
                              begin
                              disp[2,1]:=message[97];
                              disp[2,2]:=message[95];
                              disp[2,3]:=message[95];
                              disp[2,4]:=message[95];
                              end; {if not(rtd)...}

                           if (not(rtd and (ch=16))) then
                              begin
                              disp[2,5]:=fstr(scale_ipzero,3)+'     ';
                              disp[2,6]:=fstr(scale_opzero,3)+'     ';
                              disp[2,7]:=fstr(scale_gain,3)+'     ';
                              end
                           else
                              begin
                              disp[2,5]:=message[95];
                              disp[2,6]:=message[95];
                              disp[2,7]:=message[95];
                              end; {if not(rtd)}

                          write(prt,ch:2,'  ',disp[2,1],'  High :',copy(disp[2,3],1,11));
                          writeln(prt,'  I/P Zero:',copy(disp[2,5],1,11),'  Gain:',copy(disp[2,7],1,11));
                          write(prt,'Sfty Drive ',copy(disp[2,2],3,12),'Low :',copy(disp[2,4],1,11));
                          writeln(prt,'  O/P Zero:',copy(disp[2,6],1,11));
                          writeln(prt);
                       end; {with channel}
                     write(prt,chr(12));
              end; {with transmitter}
       end; {with receiver}
    saydone('  Hardcopy ');
    end   {if ioresult=0}
  else
    sayerror(' Could not produce output ');
   exit;


close(prt);
write('                  ');
textcolor(15);
textbackground(black);
end; {procedure outpt}

{**************************************************************************}
procedure hcopy;

var
   oldx,oldy,i:byte;
   done:boolean;
   op:string[12];

begin
oldx:=xcur;
oldy:=ycur;
xcur:=1;
ycur:=1;
done:=false;
rx:=recno;
op:='';
repeat
      begin
      if lpt in[1..3] then
           disp[1,1]:='   LPT'+stg(lpt,1)
         else
	   disp[1,1]:=hcfile;
      disp[1,2]:='';
      backgnd(0);
      i:=sel(6);
      case i of
           $11:hcfile:=pport(hcfile);

           $12:begin
               if lpt in[1..3] then op:='LPT'+stg(lpt,1)
			       else op:=hcfile;
               outpt(op);
               end;
           $FF:done:=true;
           end;
       end;
until done;
xcur:=oldx;
ycur:=oldy;
end;
{************************************************************************}
procedure inithardcopy;
{ initialisation of varaiable required by hardcopy routines }
begin

  rx:=0;
  tx:=1;
  ch:=1;
  lpt:=1;
  hcfile:='out.txt';

end;
end.

