unit misc;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils,crt,windows,globals,dos;
function IsRtd(rx,tx:byte):boolean;
function IsEscape:boolean;
procedure wrterror;
procedure wrtworking;
function timetest(start,limit:longint):boolean;
implementation
{**************************************************************************}
function IsRtd(rx,tx:byte):boolean;  {(rx,tx:byte):boolean}
var
   rtdt:boolean;
   i:integer;

begin
{rtdt:=false;
for i:=1 to 15 do
        if receiver[rx]^.transmitter[tx].channel[i].input_type in [13,14]
           then rtdt:=true;
 }
IsRtd:=rtdt;
end; {isrtd}

{**************************************************************************}
function IsEscape:boolean; {():boolean}

begin
IsEscape:=false;
if keypressed then
   if ReadKey=#27 then
               IsEscape:=true;
end; {IsEscape}

{**************************************************************************}


procedure wrterror;
{procedure to print out an error message after a comms error}
begin
   window(1,1,80,25);
	 gotoxy(5,23);
	 textbackground(errbar);
	 write(errmsg);
	 gotoxy(80,25);
	 write(^g);
	 delay(2000);
end;

{**************************************************************************}
procedure wrtworking;
{ prints 'Working....' message }

begin
  msgerror:=false;
  window(1,1,80,25);
  textbackground(black);
  gotoxy(1,25);
  write(message[53]);
end;
{**************************************************************************}
function timetest(start,limit:longint):boolean; {(start,limit:longint):boolean;}
{ tests if timeout expired, i.e if now-start > limit }
{ returns true if timeout }
{ uses tic which is a global variable decremented on interrupt }
{ once every 50mS. tic runs down from TROLLOVER to 0 then restarts }
{ at TROLLOVER }

var t:longint;
    tout:boolean;

begin
     tout:=false;
     t:=tic;
     if ((t-start)>0) then
                      begin
                      if ((start+TROLLOVER-t) > limit) then tout:=true;
                      end
                  else
                      begin
                      if ((start-t) > limit ) then tout:=true;
                      end;

timetest:=tout;
end; {timetest}
{**************************************************************************}
end.

