program project1;

{$mode objfpc}{$H+}

uses
  {$IFDEF UNIX}{$IFDEF UseCThreads}
  cthreads,
  {$ENDIF}{$ENDIF}
  Classes, SysUtils, CustApp, crt, windows, messages, wind, scrn, globals,
  hardc, misc, wind2, comms, synaser, synautil, synafpc, disk, demo;
   {Procedure configure_rx;}
type

  { Ex1 }

  Ex1 = class(TCustomApplication)
  protected
    procedure DoRun; override;

  public
    constructor Create(TheOwner: TComponent); override;
    destructor Destroy; override;
    procedure WriteHelp; virtual;
  end;


{ Ex1 }

procedure Ex1.DoRun;
var
  ErrorMsg: String;
begin
  // quick check parameters
  ErrorMsg:=CheckOptions('h','help');
  if ErrorMsg<>'' then begin
    ShowException(Exception.Create(ErrorMsg));
    Terminate;
    Exit;
  end;

  // parse parameters
  if HasOption('h','help') then begin
    WriteHelp;
    Terminate;
    Exit;
  end;

  { add your program here }

  // stop program loop
  Terminate;
end;

constructor Ex1.Create(TheOwner: TComponent);
begin
  inherited Create(TheOwner);
  StopOnException:=True;
end;

destructor Ex1.Destroy;
begin
  inherited Destroy;
end;

procedure Ex1.WriteHelp;
begin
  { add your help code here }
  writeln('Usage: ',ExeName,' -h');
end;
  procedure diagnostic(rx:byte);

var
   option, oldxcur,oldycur:byte;

begin
if online then
	begin
          wrtworking;
	  read_checksum(recno);
	  if not msgerror then read_switches(recno);
	  if msgerror then wrterror;
	end;

oldxcur:=xcur;
oldycur:=ycur;
xcur:=1;
ycur:=3;

repeat
    begin
    diagval;
    backgnd(0);
    option:=sel(9);
    case option of
         $13:sw301;
         $14:sw101;
         $15..$16:checksum_base(recno);
         $24:confirmram;
         else ;
         end;
    end
until option=$FF;
xcur:=oldxcur;
ycur:=oldycur;
end;

function calcout(input:real):real;
var offset:real;

begin
with receiver[recno]^.transmitter[txno].channel[chno] do
  begin
    offset:=getoffset(receiver[recno]^.data_format,input_type);
    calcout:=scale_gain*(input+offset-scale_ipzero)+scale_opzero;
  end; {with receiver}
end; {calcout}

procedure calcscales;


var
   option, oldxcur,oldycur,old:byte;
   sigzero,sigfsd,opfsd,exin,exout:real;

procedure setstart;
begin
  sigfsd:=100;
  with receiver[recno]^.transmitter[txno].channel[chno] do
  begin
   sigzero:=scale_ipzero-getoffset(receiver[recno]^.data_format,input_type);
   opfsd:=(sigfsd-sigzero)*scale_gain+scale_opzero;
  end; {with receiver}
  exin:=1;
end;


begin
oldxcur:=xcur;
oldycur:=ycur;
xcur:=1;
ycur:=2;
setstart;
repeat
    begin
    calcgain(sigzero,sigfsd,opfsd);
    exout:=calcout(exin);
    calcvals(sigzero,sigfsd,opfsd,exin,exout);
    backgnd(0);
    option:=sel(10);
    case option of
         $12:inzero(sigzero);
         $13:infsd(sigfsd);
         $14:opzero;
         $15:outfsd(opfsd);
         $17:exinput(exin);
         $18:{example output};
         $21:; {title}
         $22:begin
               escape:=false;
               old:=txno;
               tranno;
               if online and (not escape or (txno=old)) then
                 begin
                  setstart;
                  wrtworking;
                  set_scales(recno,old,chno);
                  if msgerror then wrterror;
                 end;
             end;
         $23:begin
               escape:=false;
               old:=chno;
               chano;
               if online and (not escape or (chno=old)) then
                 begin
                  setstart;
                  wrtworking;
                  set_scales(recno,txno,old);
                  if msgerror then wrterror;
                 end;
             end;
	 $24..$27:readonly2;
         else {};
	 end;
    end;
until option=$FF;
xcur:=oldxcur;
ycur:=oldycur;
wrtworking;
if online then set_scales(recno,txno,chno);
if msgerror then wrterror;
end;


Procedure configure_ch;

var
   option, oldxcur,oldycur:byte;

begin
oldxcur:=xcur;
oldycur:=ycur;
xcur:=1;
ycur:=1;

repeat
    begin
    chconfigval;
    backgnd(0);
    option:=sel(8);
    case option of
	 $11:tranno; { tx number }
         $12:tx_type; { tx type }
	 $13:chano; { channel number}
	 $14:inputype; {input type}
	 $15:ocdrive; {safety drive}
         $16:halarm;
         $17:lalarm;
	 $21:ipzero;
	 $22:opzero;
	 $23:gain;
	 $24:calcscales;
	 end;
    end
until option=$FF;
xcur:=oldxcur;
ycur:=oldycur;
end;

procedure openingvals;


begin
disp[1,1]:='';
disp[1,2]:='';
disp[1,3]:='';
disp[1,4]:='';
disp[1,5]:='';
disp[1,6]:='';
disp[1,7]:='';
disp[1,8]:='';
disp[1,9]:='';

disp[2,1]:=name;
if online then
   disp[2,2]:='   Online    '
else
   disp[2,2]:='  Offline    ';

{disp[2,3]:='    COM'+stg(port+1,1);}
disp[2,3]:='    ' + selected_port_name;
disp[2,4]:='';
disp[2,5]:='';
disp[2,6]:='';
disp[2,7]:='';

end;
Procedure configure_rx;


var
   option, oldxcur,oldycur:byte;
   Port_Name:Text;
begin
oldxcur:=xcur;
oldycur:=ycur;
xcur:=1;
ycur:=1;
repeat
    begin
    if online then readchecksum; {database checksum}
    rxconfigval;
    backgnd(0);
    option:=sel(1);
    case option of
	 $11: dfault;
	 $12: tag;
	 $13: datafmt;
	 $14: dfscale(recno,receiver[recno]^.transmitter[txno].txtype);
	 $15: noftx;
	 $16: tempunits;
	 $17: if receiver[recno]^.transmitter[txno].txtype=1 then hertz;
	 $18: checksum_mode; {checksum mode}
         $19: checksum_base(recno);
	 $21: readonly; {address hardware / software}
	 $22: address(recno,1); {address link A}
	 $23: address(recno,2);{address link B}
	 $24: readonly; {comms hardware / software}
         $25: baudrate(recno);
	 $26: sbits(recno); { stop bits}
         $27: databits(recno); {data bits}
         $28: parity(recno); { parity }
	 $29: readonly; {mode}
	 $2A: diagnostic(recno);
	 end;

    end
until option=$FF;
xcur:=oldxcur;
ycur:=oldycur;
end;
procedure opening;

var
   temp,option:byte;
   x:char;

begin
xcur:=1;
ycur:=1;

openingvals;
if (No_Of_Ports = 0) then
  begin
   backgnd(0);
   txt[0]:='COM PORT NOT EXIST';
   txt[1]:='        OK        ';
   drawwindow(30,13,1);
   if (selection(2,1,1)=1) then
              begin
              end
 {   gotoxy(1,25);
    write('COM port is not available');}
  end
else
begin
backgnd(0);
txt[0]:='    Upload  Data  ';
txt[1]:='        NO        ';
txt[2]:='        YES       ';
drawwindow(30,13,2);
if (selection(2,1,1)=2) then
              begin
               delay(500);
               upload;
              end;

end;


repeat
    begin
    openingvals;
    backgnd(0);
    option:=sel(2);
   case option of
         $11:upload;
        $12:configure_rx;
        $13:configure_ch;
         $14:copyrx;
         $15:download;
         $16:load;
	 $17:save;
	 $18:signoff;
         $21:direct;
         $22:onlinprog;
         $23:comport1;
         $24:moninput;
         $25:textdemo;
         $26:hcopy;

         end;
    end;

until option=$FE;
end;


var
                {Timer1:fptimer.TFPTimer;}
  Application: Ex1;
{  Application: aa;}
  serial1 : TBlockSerial;
  data_Rerceived : byte;
  temp,i,StrLen:integer;

begin
  Application:=Ex1.Create(nil);
  Application.Title:='Ex11';
  Application.Run;
  Application.Free;
  window(1,80,1,25);
  clrscr;
  writeln('Loading......');
  clearport;
  gotoxy(1,2);
  Column_Number:=3;
  write('Serial Port Scanning is In-Progress...');
  comportscan;

{    write(COM_Port_Name[0]);}
  initwind;
  initcomms;


  inithardcopy;
  cursoroff;
{   if (Port_Selection = true) then
      begin
           COM_Port_Status(1);
      end
   else if  ((Port_Selection = false) and (COM_Port_Name[0] <> '')) then
       begin
           COM_Port_Status(2);

       end
   else if  ((Port_Selection = false) and (COM_Port_Name[0] = '')) then
       begin
           COM_Port_Status(3);

       end; }

{  if (Port_Selection = true) then
     begin
          txt[0]:='838 Connected with';
          txt[1]:=selected_port_name;
          txt[2]:='        OK        ';
      drawwindow(30,13,2);
   if (selection(2,1,1)=1) or (IsEscape) then
    begin
    end
     end;}
  opening;
  clrscr;
  cursoron;
end.

