unit timers;

{MODBUS version 4.0 Andrew Simpson 21/12/93}

interface

uses dos,crt,comms,globals;

procedure SetIntVectors;
procedure TidyExit;


implementation

{**************************************************************************}
procedure Int1CHandler(ES,BP:WORD);
{ Interrupt handler for Timer Tic, interrupt every 50mS }
{interrupt;}
begin

dec(Tic);
if Tic=0 then tictimeout:=true;
end;
{**************************************************************************}
procedure SetIntVectors;
begin
GetIntVec($1C,Int1CSave);
SetIntVec($1C,@Int1CHandler);
end;

{**************************************************************************}
procedure RestoreIntVectors;
begin
SetIntVec($1C,Int1CSave);
end;

{**************************************************************************}
{ Exit Procedure ; called on Halt, Runtime error or normal termination }
{$F+}
procedure TidyExit;
{$F-}
begin
RestoreIntVectors;
ExitProc:=ExitSave;
end;
{**************************************************************************}

begin
end.
